#!/bin/bash

# Version 1.1.00
# UDA'Software 2009

# Questo script serve per gestire il file degli utenti abilitati
# all'invio di file tramite DCC.

dccallow_database=${HOME}/.xchat2/buduscript/dccallow.lst

if [ "${1}" == "event" ]; then
    # Aggiunge gli eventi di gestione per il DCCALLOW in modalita'
    # HIDE.
    echo '/event addh 0 text '\''$ru:$rhost'\''='\''$server:$server'\'' /budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__dccallow_man.sh check_nickname \($nick\) \($data\)'
    echo '/event addh 0 text '\''DCC$_SEND$_='\''$data /budus pipe_script_silent $HOME/.xchat2/buduscript/buduscript_script__dccallow_man.sh send_file \($ru\) \($data\)'
    
    exit 0;
fi

if [ "${1}" == "check_nickname" ]; then
    # L'utente |r0x| (~uda@Azzurra=5C3C7BCF.51-151.net24.it) ha
    # provato ad inviarti un file chiamato prova.exe. Per la ricezione
    # di questo file e' necessaria la tua autorizzazione. Se hai la
    # certezza che non si tratti di un file infetto, digita /DCCALLOW
    # +|r0x| per riceverlo
    if [ "$(echo "${3}" | grep -F DCCALLOW)" != "" ]; then
	nickname_sender=$(echo "${3}" | tr [:cntrl:] ' ' | sed s@.*/DCCALLOW\ +@@ | cut -f1 -d' ')
	if [ "${nickname_sender}" == "${2}" ]; then
	    echo "/ECHO %C8,1ATTENZIONE: Non risulti abilitato al trasferimento di file via DCC dall'utente desiderato."
	    
	    exit 0;
	fi
	
	if [ ! -f ${dccallow_database} ]; then
	    echo "/ECHO %C8,1ATTENZIONE: Non e' stato abilitato nessun utente al trasferimento di file via DCC."
	    echo "/ECHO %C7,1Se desideri abilitare un utente, usa i comandi del menu %BMenu Utente -> Abilitazione Automatica Trasferimenti DCC%O%C7,1."
	    exit 1;
	fi
	
	is_nickname_allowed=$(grep -iF "/${nickname_sender}/" ${dccallow_database})
	
	if [ "${is_nickname_allowed}" == "" ]; then
	    echo "/ECHO %C8,1ATTENZIONE: %B${nickname_sender}%O%C8,1 non e' stato abilitato al trasferimento di file via DCC."
	    echo "/ECHO %C7,1Se desideri abilitarlo, usa i comandi del menu %BMenu Utente -> Abilitazione Automatica Trasferimenti DCC%O%C7,1."
	else
	    echo "/ECHO %C4,1%B${nickname_sender}%O%C3,1 e' stato abilitato al trasferimento di file via DCC in automatico."
	    echo "/DCCALLOW +${nickname_sender}"
	    echo "/NOTICE ${nickname_sender} Messaggio Automatico: Solo ora ho abilitato il DCCALLOW; cortesemente, puoi ri-inviare il file ?"
	fi
    fi
    
    exit 0;
fi

if [ "${1}" == "send_file" ]; then
    is_nickname_allowed=$(grep -iF "/${2}/" ${dccallow_database})
    dcc_filename=$(echo "${3}" | sed s/[Dd][Cc][Cc]\ [Ss][Ee][Nn][Dd]\ // | cut -f1 -d' ')
    if [ "${is_nickname_allowed}" != "" ]; then
	echo "/ECHO %C3,1L'utente %B%C6,1${2}%O%C3,1 ha inviato il file %B%C6,01${dcc_filename}%O%C3,1 ed e' stato accettato in automatico."
	echo "/TIMER 2 DCC GET ${2}"
    else
	echo "/ECHO %C4,1L'utente %B%C6,1${2}%O%C4,1 ha inviato il file %B%C6,01${dcc_filename}%O%C4,1 ma non ha abilitazione automatica."
	echo "/ECHO %C7,1Se desideri abilitare un utente, usa i comandi del menu %BMenu Utente -> Abilitazione Automatica Trasferimenti DCC%O%C7,1."
    fi
    
    exit 0;
fi

if [ "${1}" == "list" ]; then
    if [ -f ${dccallow_database} ]; then
	for nickname in $(cat ${dccallow_database}); do
	    echo "${nickname}" | awk -F'/' '{print $2}'
	done
    else
	echo "/ECHO %C8,1ATTENZIONE: Non e' stato abilitato nessun utente al trasferimento di file via DCC."
	echo "/ECHO %C7,1Se desideri abilitare un utente, usa i comandi del menu %BMenu Utente -> Abilitazione Automatica Trasferimenti DCC%O%C7,1."
    fi

    exit 0;
fi

if [ "${2}" == "" ]; then
    echo "/ECHO %C4,1ERRORE: Non puoi inserire un nickname nullo !"
    echo "/ECHO %C3,1Selezionane uno dalla Lista Utenti."
    
    exit 1;
fi

if [ "${1}" == "add" ]; then
    cp -f ${dccallow_database} ${HOME}/.xchat2/buduscript/dccallow.bak
    echo "/DCCALLOW +${2}"
    cat ${HOME}/.xchat2/buduscript/dccallow.bak | grep -vFi "/${2}/" | sort | uniq > ${dccallow_database}
    echo "/${2}/" >> ${dccallow_database}
    echo "/ECHO %C3,1Utente %B${2}%O%C3,1 abilitato in automatico al trasferimento DCC"
    echo "/NOTICE ${2} Messaggio Automatico: Ho abilitato il DCCALLOW."
elif [ "${1}" == "del" ]; then
    cp -f ${dccallow_database} ${HOME}/.xchat2/buduscript/dccallow.bak
    echo "/DCCALLOW -${2}"
    cat ${HOME}/.xchat2/buduscript/dccallow.bak | grep -vFi "/${2}/" | sort | uniq > ${dccallow_database}
    echo "/ECHO %C4,1Utente %B${2}%O%C4,1 disabilitato al trasferimento DCC"
else
    echo "/ECHO Sintax Error, use:"
    echo "/ECHO buduscript_script_dccallow_man.sh <add/del> <nickname>"
fi

for nickname in $(cat ${dccallow_database}); do echo "${nickname}" | awk -F'/' '{print "/ECHO "$2}'; done
